///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL ViewLogFile(HWND xLogView)
{
    int MaxRead = 512;
    int LastRead = 0;
    char LocalBuffer[512 + 1];

    fflush(LogFileHandle);

    FILE *LocalSource = NULL;

    if((LocalSource = fopen(LogFileName, "rb")) == NULL)
    {
        return FALSE;
    }

    do{
        LastRead = fread(LocalBuffer, sizeof(char), MaxRead, LocalSource);
        LocalBuffer[LastRead] = '\0';
        TextBoxWrite(xLogView, LocalBuffer);
    } while(MaxRead == LastRead);

    if(LocalSource) fclose(LocalSource);

    return TRUE;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void SchedChangeAllOnMultipleRadio(HWND xDialog, BOOL Enable)
{
    EnableWindow(GetDlgItem(xDialog, 5000), Enable);
    EnableWindow(GetDlgItem(xDialog, 5001), Enable);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void SchedChangeAllOnSingleRadio(HWND xDialog, BOOL Enable)
{
    EnableWindow(GetDlgItem(xDialog, 2000), Enable);
    EnableWindow(GetDlgItem(xDialog, 2001), Enable);
    EnableWindow(GetDlgItem(xDialog, 3000), Enable);
    EnableWindow(GetDlgItem(xDialog, 3001), Enable);
    EnableWindow(GetDlgItem(xDialog, 4000), Enable);
    EnableWindow(GetDlgItem(xDialog, 4001), Enable);

    EnableWindow(GetDlgItem(xDialog, 4002), Enable);
    EnableWindow(GetDlgItem(xDialog, 4003), Enable);

    EnableWindow(GetDlgItem(xDialog, 4006), Enable);
    EnableWindow(GetDlgItem(xDialog, 4007), Enable);
    EnableWindow(GetDlgItem(xDialog, 4008), Enable);
    EnableWindow(GetDlgItem(xDialog, 4009), Enable);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void UnCheckAllWeekDays(HWND xDialog)
{
    int MainLoop = 0;

    while(MainLoop < 7)
    {
        CheckDlgButton(xDialog, (1000 + MainLoop), BST_UNCHECKED);
        MainLoop++;
    }
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CheckAllWeekDays(HWND xDialog)
{
    int MainLoop = 0;

    while(MainLoop < 7)
    {
        CheckDlgButton(xDialog, (1000 + MainLoop), BST_CHECKED);
        MainLoop++;
    }
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL LoadDBListBox(HWND DBListBox_hWnd)
{
    HSTMT fstmt;

    if(OpenDB(MasterDriver, MasterServer, MasterUID, MasterPWS, MasterDatabase) == FALSE)
    {
        ErrorMessage(JID.Dialog_hWnd, "Failed to connect to local master database");
        return FALSE;
    }

    SQLCHAR szName[50];
    SQLINTEGER cbName;

    SQLRETURN Result;

    if(!DBexecute("Select name from SysDataBases", &fstmt))
        printf("Exe Failed.\n");
    else printf("Exe passed.\n\n");

    while(TRUE)
    {
        Result = SQLFetch(fstmt);
        if(Result == SQL_ERROR)
        {
            printf("Fetch error\n");
            return FALSE;
        }

        if(Result == SQL_SUCCESS || Result == SQL_SUCCESS_WITH_INFO)
        {
            SQLGetData(fstmt, 1, SQL_C_CHAR, szName, 50, &cbName);

            InsertListBoxItem(DBListBox_hWnd, (char *)szName, -1);

            printf("%s\n", szName);
        }
        else break;
    }


    DBclose();
	return TRUE;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

DWORD WINAPI DialogThread(LPVOID xData)
{
    if(DisplaySplash)
    {
    	DialogBox(MainInstance, MAKEINTRESOURCE(ThisEdition), NULL, SplashDialog);
        Sleep(500);
    }

	DialogBox(MainInstance, MAKEINTRESOURCE(100), NULL, MainDialog);
    EndApplication = TRUE;
    return 0;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int Get_LVFocusItem(HWND ListBox)
{
    int ItemCount = ListView_GetItemCount(ListBox);
    int LocalLoop = 0;

    while(LocalLoop < ItemCount)
    {
        if( ListView_GetItemState(ListBox, LocalLoop, LVIS_FOCUSED) )
            return LocalLoop;

        LocalLoop++;
    }

	return -1;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL OpenLogFile(void)
{
    if( (LogFileHandle = fopen (LogFileName, "a+")) == NULL)
        return FALSE;

    return TRUE;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void WriteToLog(char *xMessage)
{
    fprintf(LogFileHandle, "%s\r\n", xMessage);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CloseLogFile(void)
{
    if(LogFileHandle) fclose(LogFileHandle);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void LBWrite(HWND ListBox_hWnd, char *xMessage)
{
    InsertListBoxItem(ListBox_hWnd, xMessage, -1);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

