///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL InitilizeAll(void)
{
    // Get values from the registry
    if( GetValues() == FALSE )
    {
        MessageBox(NULL, "Failed to get registry values.", TitleCaption, MB_ICONERROR + MB_SYSTEMMODAL);
        return FALSE;
    }

    DialogThread_Handle = CreateThread(NULL, 0, DialogThread, (LPVOID)0, 0, &DialogThread_ID);

    //-----------------------------------------
    INITCOMMONCONTROLSEX ICCEX;
    ICCEX.dwSize = sizeof(ICCEX);
    ICCEX.dwICC  = ICC_DATE_CLASSES;
    InitCommonControlsEx(&ICCEX);

    // Open the glogal log file
    if( OpenLogFile() == FALSE )
    {
        MessageBox(NULL, "Failed to open the log file.", TitleCaption, MB_ICONERROR + MB_SYSTEMMODAL);
        return FALSE;
    }

    // Clean the schedule structure
    InitSchedule();

    // Read the data file into memory (Failing this should not be an error)
    ReadDataBaseToSchedule();

    // Catch up all schedules that are behind to at or past the current time / date
    CalculateSchedules();

    if(DisplaySplash)
    {
        Sleep(2000);
    }

    return TRUE;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

