////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#define _WIN32_DCOM
//#define _MT

#include <objbase.h>    // for 'CoInitialize()'
#include <CommCtrl.H>
#include <ShlOBJ.H>
#include <stdio.h>      // for file operations
#include <stdlib.h>
#include <IO.h>
#include <string.h>
#include <ctype.h>      // for toupper ()
#include <process.h>    // for C library-safe _beginthreadex,_endthreadex

#include "SQL/vdi.h"        // interface declaration
#include "SQL/vdierror.h"   // error constants

#include "SQL/vdiguid.h"

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <windows.h>
#include "sql.h"
#include "sqlext.h"
#include "odbcss.h"

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "Headers/NSWFL.H"
#include "Headers/NDBSCore.H"
#include "Headers/NDBSFIO.H"

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "Headers/Definitions.H"
#include "Headers/Schedule.H"
#include "Headers/Registry.H"
#include "Headers/SQLBackup.H"

#include "Headers/SQL.H"
#include "Headers/Functions.H"
#include "Headers/Interval.H"
#include "Headers/DataBase.H"
#include "Headers/Initilize.H"

#include "Headers/TrayIcon.H"
#include "Headers/TrayHandler.H"

#include "Dialogs/MainDialog.H"
#include "Dialogs/ManBackup.H"
#include "Dialogs/ManRestore.H"
#include "Dialogs/Schedule.H"
#include "Dialogs/AddSchedule.H"
#include "Dialogs/AddBackupOptions.H"
#include "Dialogs/AddSQLOptions.H"
#include "Dialogs/EditSchedule.H"
#include "Dialogs/EditBackupOptions.H"
#include "Dialogs/EditSQLOptions.H"
#include "Dialogs/SplashDialog.H"
#include "Dialogs/ViewSchedule.H"
#include "Dialogs/SelectDB.H"
#include "Dialogs/SQLPassword.H"
#include "Dialogs/ViewLog.H"

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevious, LPSTR CmdLine, int CmdShow)
{
	HANDLE xMutex = NULL;

	MainInstance = hInstance;

    if(ThisEdition == DesktopEdition)
    {
        if(IsWinNT() == TRUE)
        {
            MessageBox(NULL, "This application was not designed to run on Windows NT based machines.", TitleCaption, 0 + MB_ICONASTERISK + MB_SYSTEMMODAL);
            return 0;
        }
    }

	if( (xMutex = OpenMutex(SYNCHRONIZE, FALSE, TitleCaption)) )
	{
		MessageBox(NULL, "Only one instance can run at a time." , TitleCaption, 0 + MB_ICONASTERISK + MB_SYSTEMMODAL);
		ReleaseMutex(xMutex);
		CloseHandle(xMutex);
		return 0;
	}
	xMutex = CreateMutex(0, 0, TitleCaption);

    BOOL Result = InitilizeAll();

    if(DisplaySplash)
    {
        EndDialog(SplashDialog_hWnd, 0);
    }

    if(Result == FALSE)
        return 0;

    while(StartupComplete == FALSE)
    {
        Sleep(1000);
    }

    LoadTrayIcon(101, TitleCaption);

    if(SaveScheduleToDataBase() == FALSE)
        MessageBox(NULL, "Failed to save changes to database..", TitleCaption, MB_ICONERROR + MB_SYSTEMMODAL);

    // Set the registry values
    if(SetValues() == FALSE)
        MessageBox(NULL, "Failed to set registry values.", TitleCaption, MB_ICONERROR + MB_SYSTEMMODAL);

    // Close the global log file
    CloseLogFile();

	ReleaseMutex(xMutex);
	CloseHandle(xMutex);

	return 0;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

