[Setup]
;-- Main Setup Information
 AppName                = SQL Backup
 AppVerName             = SQL Backup 1.0.0.2
 AppCopyright           = Copyright  1995-2003 NetWorkDLS.
 DefaultDirName         = {pf}\NetWorkDLS\SQL Backup
 DefaultGroupName       = NetWorkDLS\SQL Backup
 UninstallDisplayIcon   = {app}\SQLBackup.Exe
 UninstallStyle         = Modern
 WizardImageFile        = Resources\LgSetup.bmp
 WizardSmallImageFile   = Resources\SmSetup.bmp
 PrivilegesRequired     = PowerUser
 Uninstallable          = Yes
 AppMutex               = SQL Backup
 LicenseFile            = Resources\EULA.txt
 compression            = ZIP/9
 OutputBaseFilename     = Setup

;-- Windows 2000 & XP (Support Dialog)
 AppPublisher    = NetWorkDLS
 AppPublisherURL = http://www.NetWorkDLS.com/
 AppUpdatesURL   = http://www.NetWorkDLS.com/
 AppVersion      = 1.0.0.2

[Files]
 Source: "..\Release\SQLBackup.Exe";          DestDir: "{app}"; Flags: IgnoreVersion;
 Source: "Resources\EULA.txt";                DestDir: "{app}"; Flags: IgnoreVersion;
 Source: "Libraries\NSWFL.Dll";               DestDir: "{app}"; Flags: IgnoreVersion;
 Source: "Libraries\NDBSCore.Dll";            DestDir: "{app}"; Flags: IgnoreVersion;
 Source: "Libraries\NDBSFIO.Dll";             DestDir: "{app}"; Flags: IgnoreVersion;

[Icons]
 Name: "{group}\SQL Backup";       Filename: "{app}\SQLBackup.Exe";
 Name: "{group}\Uninstall";        Filename: "{uninstallexe}";

[Dirs]
 Name: "{app}\Logs"
 Name: "{app}\Data"

[Registry]
 Root: HKLM; Subkey: "Software\NetWorkDLS\SQLBackup"; Flags: UninsDeleteKey

 Root: HKLM; Subkey: "Software\NetWorkDLS\SQLBackup"; ValueName: "LogFileName";     ValueType: String; ValueData: "{app}\Logs\SQLBackup.Log";
 Root: HKLM; Subkey: "Software\NetWorkDLS\SQLBackup"; ValueName: "SavedDataFile";   ValueType: String; ValueData: "{app}\SQLBackup.Dat";
 Root: HKLM; Subkey: "Software\NetWorkDLS\SQLBackup"; ValueName: "AllOnHold";       ValueType: Dword;  ValueData: "0";
 Root: HKLM; Subkey: "Software\NetWorkDLS\SQLBackup"; ValueName: "DisplaySplash";   ValueType: Dword;  ValueData: "1";
 
 Root: HKLM; Subkey: "Software\NetWorkDLS\SQLBackup"; ValueName: "MasterDatabase";  ValueType: String; ValueData: "Master";
 Root: HKLM; Subkey: "Software\NetWorkDLS\SQLBackup"; ValueName: "MasterDriver";    ValueType: String; ValueData: "{{SQL Server}";
 Root: HKLM; Subkey: "Software\NetWorkDLS\SQLBackup"; ValueName: "MasterPWS";       ValueType: String; ValueData: "";
 Root: HKLM; Subkey: "Software\NetWorkDLS\SQLBackup"; ValueName: "MasterServer";    ValueType: String; ValueData: "(Local)";
 Root: HKLM; Subkey: "Software\NetWorkDLS\SQLBackup"; ValueName: "MasterUID";       ValueType: String; ValueData: "sa";


 Root: HKLM; Subkey: "Software\NetWorkDLS\SQLBackup"; ValueName: "BackupFile";      ValueType: String; ValueData: "{app}\Data\SQLRestore.sbf";
 Root: HKLM; Subkey: "Software\NetWorkDLS\SQLBackup"; ValueName: "BackupDataBase";  ValueType: String; ValueData: "";
 Root: HKLM; Subkey: "Software\NetWorkDLS\SQLBackup"; ValueName: "BackupUserID";    ValueType: String; ValueData: "sa";
 Root: HKLM; Subkey: "Software\NetWorkDLS\SQLBackup"; ValueName: "BackupUserPW";    ValueType: String; ValueData: "";
 Root: HKLM; Subkey: "Software\NetWorkDLS\SQLBackup"; ValueName: "BackupServer";    ValueType: String; ValueData: "(Local)";
 Root: HKLM; Subkey: "Software\NetWorkDLS\SQLBackup"; ValueName: "BackupDriver";    ValueType: String; ValueData: "{{SQL Server}";
 Root: HKLM; Subkey: "Software\NetWorkDLS\SQLBackup"; ValueName: "BackupTrusted";   ValueType: Dword;  ValueData: "1";

 Root: HKLM; Subkey: "Software\NetWorkDLS\SQLBackup"; ValueName: "RestoreFile";     ValueType: String; ValueData: "{app}\Data\SQLRestore.sbf";
 Root: HKLM; Subkey: "Software\NetWorkDLS\SQLBackup"; ValueName: "RestoreDataBase"; ValueType: String; ValueData: "";
 Root: HKLM; Subkey: "Software\NetWorkDLS\SQLBackup"; ValueName: "RestoreUserID";   ValueType: String; ValueData: "sa";
 Root: HKLM; Subkey: "Software\NetWorkDLS\SQLBackup"; ValueName: "RestoreUserPW";   ValueType: String; ValueData: "";
 Root: HKLM; Subkey: "Software\NetWorkDLS\SQLBackup"; ValueName: "RestoreServer";   ValueType: String; ValueData: "(Local)";
 Root: HKLM; Subkey: "Software\NetWorkDLS\SQLBackup"; ValueName: "RestoreDriver";   ValueType: String; ValueData: "{{SQL Server}";
 Root: HKLM; Subkey: "Software\NetWorkDLS\SQLBackup"; ValueName: "RestoreTrusted";  ValueType: Dword;  ValueData: "1";

